/*    DTN's Super SmartCar Sharp 2Y0A21 IR Proximity Sensor Test and Calibration Program
         Available at http://devestechnet.com/NewTech/SuperSmartCar#ArduinoSoftware
          This program is designed for the front facing Sharp 2Y0A21 IR Proximity
              Sensor facing forward on the front fascia of the SuperSmartCar.
   
                       Distance 10 to 80cm or 4" to 31" Detection Range
                       Analog Output Signal (Nice 1mm increment detection capability)
                       Detection Angle: 10 Degrees
                       Adjustable detection distance via software(below):

                        Open Serial Monitor to view Sensor Output */

float faciaCenterSensorPin = A5;
float cmDistance;
float inchDistance;

void setup() {
  Serial.begin(115200);  
}

void loop() {
  float volts = analogRead(faciaCenterSensorPin) * 0.0048828125;
  float cmDistance = 32 * pow(volts,-1.10);
  float inchDistance = cmDistance / 2.54;
  if (cmDistance <= 80) {                  /* Limit the visible data to the range of the Sensor */
    Serial.println("\n    Obstruction Detected in approx. ");
    Serial.print(inchDistance);
    Serial.print(" Inches \t");
    Serial.print("or \t");
    Serial.print(cmDistance);
    Serial.println(" Centimeters");
  }
  if (cmDistance <= 10) {                    /* Use this statement to contain your instructions */
    //allStop();
  }
  delay(50);                                           /* Makes the data slightly more readable */
}

